# Set default elasticsearch settings
{% set default_config = salt.grains.filter_by({
  'default':
  {
    'elasticsearch':
    {
      'repo_version': '2.x',
      'repo_baseurl': 'https://packages.elastic.co/elasticsearch/2.x/centos',
      'repo_gpgkey': 'https://packages.elastic.co/GPG-KEY-elasticsearch',
      'debrepo_baseurl': 'deb https://packages.elastic.co/elasticsearch/2.x/debian stable main',
      'debrepo_keyurl': 'https://packages.elastic.co/GPG-KEY-elasticsearch',
      'restart_service_after_state_change': 'true',
      'cluster_name': 'graylog',
      'master_node': 'true',
      'data_node': 'true',
      'minimum_masters': '2',
      'log_path': '/var/log/elasticsearch',
      'data_path': '/elasticsearch/data',
      'es_heap_size': '2g',
      'mlockall': 'true',
      'network_host': '0.0.0.0',
      'unicast_hosts': [],
      'initial_primaries_recoveries': '2',
      'concurrent_recoveries': '2',
      'recovery_max_bytes': '100mb',
      'recovery_concurrent_streams': '5',
      'sources': [],
      'mounts':
      {
        'create_lvm': 'false',
        'lvm_pv_name': '/dev/sdc',
        'lvm_vg_name': 'graylog',
        'lvm_data_lv_name': 'es_data',
        'lvm_data_lv_size': '20G',
        'lvm_archive_lv_name': 'es_archive',
        'lvm_archive_lv_size': '20G',
        'data_dir_name': '/elasticsearch/data',
        'data_mount_fstype': 'ext4',
        'data_mount_device': '/dev/mapper/graylog-es_data',
        'archive_dir_name': '/elasticsearch/archive',
        'use_archive_dir': 'false',
        'archive_mount_fstype': 'ext4',
        'archive_mount_device': '/dev/mapper/graylog-es_archive',
      },
    },
  },
  'esnode00':
  {
    'elasticsearch':
    {
      'master_node': 'true',
      'data_node': 'false',
      'es_heap_size': '4g',
    },
  },
  'esnode01':
  {
    'elasticsearch':
    {
      'master_node': 'false',
      'data_node': 'true',
      'es_heap_size': '8g',
    },
  },
  'esnode02':
  {
    'elasticsearch':
    {
      'master_node': 'false',
      'data_node': 'true',
      'es_heap_size': '8g',
    },
  },
}, grain='host', base='default') %}

# Set kernel parameters to tune this instance
{% set kernel = {
  'kernel':
  {
    'vm_swappiness': '0',
    'vm_max_map_count': '262144',
  },
} %}

# Configure java package name
{% set java_map = {
    'Debian':
    {
      'elasticsearch_java':
      {
        'java_pkg_name': 'openjdk-8-jdk-headless',
      },
    },
    'RedHat':
    {
      'elasticsearch_java':
      {
        'java_pkg_name': 'java-1.8.0-openjdk-headless',
      },
    },
} %}
{% set java = java_map.get(grains.os_family) %}
{% do default_config.update(java) %}
# Update the default config with kernel and firewall config
{% do default_config.update(kernel) %}

# Merge the default settings with pillar data
{% set host_lookup = salt['pillar.get']('elasticsearch:lookup', default=default_config, merge=True) %}
